#include "stdafx.h"
#include "output.h"
#include "decoder.h"
#include "external.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
					  DWORD  ul_reason_for_call, 
					  LPVOID lpReserved
					  )
{
    switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
    }
    return TRUE;
}

// Init function
__declspec(dllexport) bool Init(void)
{
	MessageBox(NULL, "Init called", "Init", MB_OK);
	
	// Replace the following lines with your own registrations
	RegisterDecoder(proto_enum_tcp, 7777, &tcpDecode);
	RegisterDecodeAs(proto_enum_tcp, "TCP 7777", &tcpDecode, &tcpConfig, &TcpTest);
	RegisterHelp("TCP 7777", "tcp7777.chm");
	
	RegisterDecoder(proto_enum_udp, 7777, &udpDecode);
	RegisterDecodeAs(proto_enum_udp, "UDP 7777", &udpDecode, &udpConfig, &UdpTest);
	RegisterHelp("UDP 7777", "udp7777.chm");
	
	RegisterDecoder(proto_enum_ipproto, 17, &ipDecode);

	return true;
}


__declspec(dllexport) void Drop(__int64 ids[], int count)
{
	// One or more packets are removed

	return;
}


__declspec(dllexport) bool UdpTest(int port) {
	// User selected DecodeAs for UDP 7777 protocol

	return true;
}


__declspec(dllexport) bool TcpTest(int port) {
	// User selected DecodeAs for TCP 7777 protocol

	return true;
}

__declspec(dllexport) int udpDecode(OutputTree *otp, unsigned char *packet, int pack_size, __int64 protid, int curLevel, int &CountBits, int isSummary,  NewCString& ProtName, int ByteOrder, int DataTypeByteOrder, int DataFieldByteOrder)
{
	otp->PutString(0, 0, 0, pack_size, "UDP 7777", "");

	// here you can see how to access UDP header data
	if (otp->udp.IsInitialized) {
		otp->PutInt(1, 0, 0, 0, "Source UDP port", otp->udp.src_port);
	}
	return ERR_OK;
}

__declspec(dllexport) int tcpDecode(OutputTree *otp, unsigned char *packet, int pack_size, __int64 protid, int curLevel, int &CountBits, int isSummary,  NewCString& ProtName, int ByteOrder, int DataTypeByteOrder, int DataFieldByteOrder)
{
	otp->PutString(0, 0, 0, pack_size, "TCP 7777", "");
	
	// here you can see how to access TCP header data
	if (otp->tcp.IsInitialized) {
		otp->PutInt(1, 0, 0, 0, "Source TCP port", otp->tcp.src_port);
	}
	return ERR_OK;
}

__declspec(dllexport) int ipDecode(OutputTree *otp, unsigned char *packet, int pack_size, __int64 protid, int curLevel, int &CountBits, int isSummary,  NewCString& ProtName, int ByteOrder, int DataTypeByteOrder, int DataFieldByteOrder)
{
  otp->PutString(0, 0, 0, pack_size, "UDP replacement", "");

  return ERR_OK;
}

__declspec(dllexport) void tcpConfig(HWND window)
{
	MessageBox(window, "Configuration comes here!", "TCP 7777 config", MB_ICONSTOP | MB_OK);
}

__declspec(dllexport) void udpConfig(HWND window)
{
	MessageBox(window, "Configuration comes here!", "UDP 7777 config", MB_ICONSTOP | MB_OK);
}

__declspec(dllexport) void Event(HWND window, bool create)
{
	if (create) {
		// Log created/loaded
	} else {
		// Log closed/cleared
	}
}
